// libmr: markright is the right markup language

#ifndef libmr_h
#define libmr_h

#define MR_CHUNK_SIZE 512

enum mr_parse_state {
    MR_IN_NOTHING,
    MR_IN_PARAGRAPH,
    MR_IN_PREFORMATTED,
    MR_IN_QUOTED,
    MR_IN_LIST
};

// linked list for generated text chunks
struct mr_chunk {
    char chunk[MR_CHUNK_SIZE];
    struct mr_chunk *next;
};

// markright state
struct mr_st {
    // state of the parser
    enum mr_parse_state pst;
    // list of generated text chunks
    // text -> first chunk, last -> newest added chunk
    struct mr_chunk *text, *last;
};

// initialization and destruction
void libmr_init(struct mr_st *);
void libmr_free(struct mr_st *);



#endif // libmr_h

